Merge git://git.kernel.org/pub/scm/linux/kernel/git/bpf/bpf
[sfrench/cifs-2.6.git] / scripts / link-vmlinux.sh
1 #!/bin/sh
2 # SPDX-License-Identifier: GPL-2.0
3 #
4 # link vmlinux
5 #
6 # vmlinux is linked from the objects selected by $(KBUILD_VMLINUX_OBJS) and
7 # $(KBUILD_VMLINUX_LIBS). Most are built-in.a files from top-level directories
8 # in the kernel tree, others are specified in arch/$(ARCH)/Makefile.
9 # $(KBUILD_VMLINUX_LIBS) are archives which are linked conditionally
10 # (not within --whole-archive), and do not require symbol indexes added.
11 #
12 # vmlinux
13 #   ^
14 #   |
15 #   +--< $(KBUILD_VMLINUX_OBJS)
16 #   |    +--< init/built-in.a drivers/built-in.a mm/built-in.a + more
17 #   |
18 #   +--< $(KBUILD_VMLINUX_LIBS)
19 #   |    +--< lib/lib.a + more
20 #   |
21 #   +-< ${kallsymso} (see description in KALLSYMS section)
22 #
23 # vmlinux version (uname -v) cannot be updated during normal
24 # descending-into-subdirs phase since we do not yet know if we need to
25 # update vmlinux.
26 # Therefore this step is delayed until just before final link of vmlinux.
27 #
28 # System.map is generated to document addresses of all kernel symbols
29
30 # Error out on error
31 set -e
32
33 # Nice output in kbuild format
34 # Will be supressed by "make -s"
35 info()
36 {
37         if [ "${quiet}" != "silent_" ]; then
38                 printf "  %-7s %s\n" "${1}" "${2}"
39         fi
40 }
41
42 # Link of vmlinux.o used for section mismatch analysis
43 # ${1} output file
44 modpost_link()
45 {
46         local objects
47
48         objects="--whole-archive                                \
49                 ${KBUILD_VMLINUX_OBJS}                          \
50                 --no-whole-archive                              \
51                 --start-group                                   \
52                 ${KBUILD_VMLINUX_LIBS}                          \
53                 --end-group"
54
55         ${LD} ${KBUILD_LDFLAGS} -r -o ${1} ${objects}
56 }
57
58 objtool_link()
59 {
60         local objtoolopt;
61
62         if [ -n "${CONFIG_VMLINUX_VALIDATION}" ]; then
63                 objtoolopt="check"
64                 if [ -z "${CONFIG_FRAME_POINTER}" ]; then
65                         objtoolopt="${objtoolopt} --no-fp"
66                 fi
67                 if [ -n "${CONFIG_GCOV_KERNEL}" ]; then
68                         objtoolopt="${objtoolopt} --no-unreachable"
69                 fi
70                 if [ -n "${CONFIG_RETPOLINE}" ]; then
71                         objtoolopt="${objtoolopt} --retpoline"
72                 fi
73                 if [ -n "${CONFIG_X86_SMAP}" ]; then
74                         objtoolopt="${objtoolopt} --uaccess"
75                 fi
76                 info OBJTOOL ${1}
77                 tools/objtool/objtool ${objtoolopt} ${1}
78         fi
79 }
80
81 # Link of vmlinux
82 # ${1} - output file
83 # ${2}, ${3}, ... - optional extra .o files
84 vmlinux_link()
85 {
86         local lds="${objtree}/${KBUILD_LDS}"
87         local output=${1}
88         local objects
89         local strip_debug
90
91         info LD ${output}
92
93         # skip output file argument
94         shift
95
96         # The kallsyms linking does not need debug symbols included.
97         if [ "$output" != "${output#.tmp_vmlinux.kallsyms}" ] ; then
98                 strip_debug=-Wl,--strip-debug
99         fi
100
101         if [ "${SRCARCH}" != "um" ]; then
102                 objects="--whole-archive                        \
103                         ${KBUILD_VMLINUX_OBJS}                  \
104                         --no-whole-archive                      \
105                         --start-group                           \
106                         ${KBUILD_VMLINUX_LIBS}                  \
107                         --end-group                             \
108                         ${@}"
109
110                 ${LD} ${KBUILD_LDFLAGS} ${LDFLAGS_vmlinux}      \
111                         ${strip_debug#-Wl,}                     \
112                         -o ${output}                            \
113                         -T ${lds} ${objects}
114         else
115                 objects="-Wl,--whole-archive                    \
116                         ${KBUILD_VMLINUX_OBJS}                  \
117                         -Wl,--no-whole-archive                  \
118                         -Wl,--start-group                       \
119                         ${KBUILD_VMLINUX_LIBS}                  \
120                         -Wl,--end-group                         \
121                         ${@}"
122
123                 ${CC} ${CFLAGS_vmlinux}                         \
124                         ${strip_debug}                          \
125                         -o ${output}                            \
126                         -Wl,-T,${lds}                           \
127                         ${objects}                              \
128                         -lutil -lrt -lpthread
129                 rm -f linux
130         fi
131 }
132
133 # generate .BTF typeinfo from DWARF debuginfo
134 # ${1} - vmlinux image
135 # ${2} - file to dump raw BTF data into
136 gen_btf()
137 {
138         local pahole_ver
139
140         if ! [ -x "$(command -v ${PAHOLE})" ]; then
141                 echo >&2 "BTF: ${1}: pahole (${PAHOLE}) is not available"
142                 return 1
143         fi
144
145         pahole_ver=$(${PAHOLE} --version | sed -E 's/v([0-9]+)\.([0-9]+)/\1\2/')
146         if [ "${pahole_ver}" -lt "116" ]; then
147                 echo >&2 "BTF: ${1}: pahole version $(${PAHOLE} --version) is too old, need at least v1.16"
148                 return 1
149         fi
150
151         vmlinux_link ${1}
152
153         info "BTF" ${2}
154         LLVM_OBJCOPY=${OBJCOPY} ${PAHOLE} -J ${1}
155
156         # Create ${2} which contains just .BTF section but no symbols. Add
157         # SHF_ALLOC because .BTF will be part of the vmlinux image. --strip-all
158         # deletes all symbols including __start_BTF and __stop_BTF, which will
159         # be redefined in the linker script. Add 2>/dev/null to suppress GNU
160         # objcopy warnings: "empty loadable segment detected at ..."
161         ${OBJCOPY} --only-section=.BTF --set-section-flags .BTF=alloc,readonly \
162                 --strip-all ${1} ${2} 2>/dev/null
163         # Change e_type to ET_REL so that it can be used to link final vmlinux.
164         # Unlike GNU ld, lld does not allow an ET_EXEC input.
165         printf '\1' | dd of=${2} conv=notrunc bs=1 seek=16 status=none
166 }
167
168 # Create ${2} .o file with all symbols from the ${1} object file
169 kallsyms()
170 {
171         info KSYM ${2}
172         local kallsymopt;
173
174         if [ -n "${CONFIG_KALLSYMS_ALL}" ]; then
175                 kallsymopt="${kallsymopt} --all-symbols"
176         fi
177
178         if [ -n "${CONFIG_KALLSYMS_ABSOLUTE_PERCPU}" ]; then
179                 kallsymopt="${kallsymopt} --absolute-percpu"
180         fi
181
182         if [ -n "${CONFIG_KALLSYMS_BASE_RELATIVE}" ]; then
183                 kallsymopt="${kallsymopt} --base-relative"
184         fi
185
186         local aflags="${KBUILD_AFLAGS} ${KBUILD_AFLAGS_KERNEL}               \
187                       ${NOSTDINC_FLAGS} ${LINUXINCLUDE} ${KBUILD_CPPFLAGS}"
188
189         local afile="`basename ${2} .o`.S"
190
191         ${NM} -n ${1} | scripts/kallsyms ${kallsymopt} > ${afile}
192         ${CC} ${aflags} -c -o ${2} ${afile}
193 }
194
195 # Perform one step in kallsyms generation, including temporary linking of
196 # vmlinux.
197 kallsyms_step()
198 {
199         kallsymso_prev=${kallsymso}
200         kallsyms_vmlinux=.tmp_vmlinux.kallsyms${1}
201         kallsymso=${kallsyms_vmlinux}.o
202
203         vmlinux_link ${kallsyms_vmlinux} "${kallsymso_prev}" ${btf_vmlinux_bin_o}
204         kallsyms ${kallsyms_vmlinux} ${kallsymso}
205 }
206
207 # Create map file with all symbols from ${1}
208 # See mksymap for additional details
209 mksysmap()
210 {
211         ${CONFIG_SHELL} "${srctree}/scripts/mksysmap" ${1} ${2}
212 }
213
214 sorttable()
215 {
216         ${objtree}/scripts/sorttable ${1}
217 }
218
219 # Delete output files in case of error
220 cleanup()
221 {
222         rm -f .btf.*
223         rm -f .tmp_System.map
224         rm -f .tmp_vmlinux*
225         rm -f System.map
226         rm -f vmlinux
227         rm -f vmlinux.o
228 }
229
230 on_exit()
231 {
232         if [ $? -ne 0 ]; then
233                 cleanup
234         fi
235 }
236 trap on_exit EXIT
237
238 on_signals()
239 {
240         exit 1
241 }
242 trap on_signals HUP INT QUIT TERM
243
244 # Use "make V=1" to debug this script
245 case "${KBUILD_VERBOSE}" in
246 *1*)
247         set -x
248         ;;
249 esac
250
251 if [ "$1" = "clean" ]; then
252         cleanup
253         exit 0
254 fi
255
256 # We need access to CONFIG_ symbols
257 . include/config/auto.conf
258
259 # Update version
260 info GEN .version
261 if [ -r .version ]; then
262         VERSION=$(expr 0$(cat .version) + 1)
263         echo $VERSION > .version
264 else
265         rm -f .version
266         echo 1 > .version
267 fi;
268
269 # final build of init/
270 ${MAKE} -f "${srctree}/scripts/Makefile.build" obj=init need-builtin=1
271
272 #link vmlinux.o
273 info LD vmlinux.o
274 modpost_link vmlinux.o
275 objtool_link vmlinux.o
276
277 # modpost vmlinux.o to check for section mismatches
278 ${MAKE} -f "${srctree}/scripts/Makefile.modpost" MODPOST_VMLINUX=1
279
280 info MODINFO modules.builtin.modinfo
281 ${OBJCOPY} -j .modinfo -O binary vmlinux.o modules.builtin.modinfo
282 info GEN modules.builtin
283 # The second line aids cases where multiple modules share the same object.
284 tr '\0' '\n' < modules.builtin.modinfo | sed -n 's/^[[:alnum:]:_]*\.file=//p' |
285         tr ' ' '\n' | uniq | sed -e 's:^:kernel/:' -e 's/$/.ko/' > modules.builtin
286
287 btf_vmlinux_bin_o=""
288 if [ -n "${CONFIG_DEBUG_INFO_BTF}" ]; then
289         btf_vmlinux_bin_o=.btf.vmlinux.bin.o
290         if ! gen_btf .tmp_vmlinux.btf $btf_vmlinux_bin_o ; then
291                 echo >&2 "Failed to generate BTF for vmlinux"
292                 echo >&2 "Try to disable CONFIG_DEBUG_INFO_BTF"
293                 exit 1
294         fi
295 fi
296
297 kallsymso=""
298 kallsymso_prev=""
299 kallsyms_vmlinux=""
300 if [ -n "${CONFIG_KALLSYMS}" ]; then
301
302         # kallsyms support
303         # Generate section listing all symbols and add it into vmlinux
304         # It's a three step process:
305         # 1)  Link .tmp_vmlinux1 so it has all symbols and sections,
306         #     but __kallsyms is empty.
307         #     Running kallsyms on that gives us .tmp_kallsyms1.o with
308         #     the right size
309         # 2)  Link .tmp_vmlinux2 so it now has a __kallsyms section of
310         #     the right size, but due to the added section, some
311         #     addresses have shifted.
312         #     From here, we generate a correct .tmp_kallsyms2.o
313         # 3)  That link may have expanded the kernel image enough that
314         #     more linker branch stubs / trampolines had to be added, which
315         #     introduces new names, which further expands kallsyms. Do another
316         #     pass if that is the case. In theory it's possible this results
317         #     in even more stubs, but unlikely.
318         #     KALLSYMS_EXTRA_PASS=1 may also used to debug or work around
319         #     other bugs.
320         # 4)  The correct ${kallsymso} is linked into the final vmlinux.
321         #
322         # a)  Verify that the System.map from vmlinux matches the map from
323         #     ${kallsymso}.
324
325         kallsyms_step 1
326         kallsyms_step 2
327
328         # step 3
329         size1=$(${CONFIG_SHELL} "${srctree}/scripts/file-size.sh" ${kallsymso_prev})
330         size2=$(${CONFIG_SHELL} "${srctree}/scripts/file-size.sh" ${kallsymso})
331
332         if [ $size1 -ne $size2 ] || [ -n "${KALLSYMS_EXTRA_PASS}" ]; then
333                 kallsyms_step 3
334         fi
335 fi
336
337 vmlinux_link vmlinux "${kallsymso}" ${btf_vmlinux_bin_o}
338
339 if [ -n "${CONFIG_BUILDTIME_TABLE_SORT}" ]; then
340         info SORTTAB vmlinux
341         if ! sorttable vmlinux; then
342                 echo >&2 Failed to sort kernel tables
343                 exit 1
344         fi
345 fi
346
347 info SYSMAP System.map
348 mksysmap vmlinux System.map
349
350 # step a (see comment above)
351 if [ -n "${CONFIG_KALLSYMS}" ]; then
352         mksysmap ${kallsyms_vmlinux} .tmp_System.map
353
354         if ! cmp -s System.map .tmp_System.map; then
355                 echo >&2 Inconsistent kallsyms data
356                 echo >&2 Try "make KALLSYMS_EXTRA_PASS=1" as a workaround
357                 exit 1
358         fi
359 fi